/**********************************************************************/
/** Copyright (C) 2021 - Université Catholique de Louvain		**/
/** secantmfh version 2021.1						**/
/** Author: Mohamed HADDAD (immc-MEMA)				**/
/** Contact: mohamed.haddad@uclouvain.be				**/
/** Use of this source code is governed by an UCL-style license	**/ 
/** All Rights Reserved						**/
/** This project has received funding from the European 		**/
/** Union’s Horizon 2020 research and innovation program		**/
/** under grant agreement No 862015					**/
/***********************************************************************/


#ifndef LOOPS_H
#define LOOPS_H 1

#include "matprop.h"
#include "state.h"

/** Compute the macro stress at tn+1 from values at tn and the strain increment dstrn_r **/ 

int computestrsmacro (MATPROP *inclprop, MATPROP *matrprop, double tn, double dt, double dt_unload,char *computestrs, \
                       STATEMACRO *macrotn, STATEMACRO *macrotn_res, STATEMACRO *macrotr, double *dstrnmacro_r, double *olddstrn1_r, double olddt,\
                       STATE *incltn, STATE *incltn_res, STATE *incltr, STATE *matrtn, STATE *matrtn_res, STATE *matrtr);



/** Find the correct strain increment dstrn_r	**/

int finddstrn1_r (MATPROP *inclprop, MATPROP *matrprop, double *dstrnmacro_r, double *olddstrn1_r, \
		double olddt, double tn, double dt, double dt_unload, STATEMACRO *macrotn, STATEMACRO *macrotn_res, STATEMACRO *macrotr, \
		STATE *incltn, STATE *incltn_res, STATE *incltr, STATE *matrtn, STATE *matrtn_res, STATE *matrtr);
		

/** Compute a new iteration of the strain increment dstrn1_r in the inclusions from a previous value **/

int compute_dstrn1tr_r(MATPROP *inclprop, MATPROP *matrprop, double *dstrnmacro_r, double *dstrn1_r, double timetn, double dt, double dt_unload,\
		  STATE *incltn, STATE *incltn_res, STATE *incltr, STATE *matrtn, STATE *matrtn_res, STATE *matrtr, \
		  STATEMACRO *macrotn, STATEMACRO *macrotn_res, STATEMACRO *macrotr, double *dstrn1tr_r);

#endif
